# Scoop
[![IRC](https://img.shields.io/badge/ircd.chat-%23tcpdirect-blue.svg)](ircs://ircd.chat:6697/#tcpdirect) [![License: GPL v3](https://img.shields.io/badge/License-GPLv3-blue.svg)](https://www.gnu.org/licenses/gpl-3.0)

Scoop will scrape free proxies & run a validating round-robin proxy pool.

## 📋 Requirements

```
go (1.20+)
jq
curl
parallel
```

## ⚙️ Installation
```
git clone https://git.tcp.direct/perp/scoop
cd scoop
go build scoop.go
```

## 📝 Configuration
#### You must manually edit the `scoop.go` file
### 📀 Round-robin proxy
`workers` - Thread amount for checking proxies\
`debug` - Enable debug logs for the pool\
`recycle` - Recycle proxies in the pool\
`redact` - Hide proxy address from debug logs\
`remove` - Remove proxy from pool after x amount of tries\
`timeout` - Proxy connection timeout for validation

### 💿 Socks5 proxy
`proxy` - Enable socks5 proxy\
`address` - Listener IP address & port\
`username` - Username for connecting\
`password` - Password for connecting

## ⚡️ Usage
```
ulimit -n <workers-amount>
./scrape
./scoop
```
##### Optional: Manually edit `test` & run it

## ⚠️ License
##### Scoop is provided under the [GNU General Public License v3.0](./LICENSE)
###### Developers are not responsible for any misuse
